;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; FILE: entity.h.s
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;-----------------------------LICENSE NOTICE------------------------------------
;;    Crocker. A game for AmstradCPC.
;;    Copyright (C) 2018  Merienda
;;          Sara Vilaplana Rua
;;          Enrique Cortés Tarraga
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.macro DefineEntity _name, _x, _y, _vx, _vy, _w, _h, _col, _upd
_name: 
   .db    _x, _y     ;; X, Y
   .db   _vx, _vy    ;; VX, VY
   .db    _w, _h     ;; W, H
   .db   _col        ;; Color
   .dw   _upd        ;; Update 
.endm
.macro DefineEntityDefault _name, _suf
   DefineEntity _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0, 0xFFFF
.endm
.macro DefineNEntities _name, _n
   _c = 0
   .rept _n
      DefineEntityDefault _name, \_c
      _c = _c + 1
   .endm
.endm
e_x = 0
e_y = 1
e_vx = 2
e_vy = 3
e_w = 4
e_h = 5
e_col = 6
e_up_l = 7
e_up_h = 8


.globl ent_draw
.globl ent_draw_coches
.globl ent_draw_bocata
.globl ent_draw_camion
.globl ent_draw_fuego
.globl ent_clear
.globl ent_clear_coches
.globl ent_update
.globl ent_checkCollision
.globl ent_checkCollisionBocadillo


.globl hero_data

.globl bocadillo

.globl fuego
.globl fuego1

.globl camion2
.globl coche1
.globl coche2